---
title: Pipeline operator (|>)
slug: Web/JavaScript/Reference/Operators/Pipeline_operator
tags:
  - Chaining
  - Experimental
  - JavaScript
  - Language feature
  - Operator
  - Pipeline
---
<div>{{jsSidebar("Operators")}}</div>

<p>The experimental pipeline operator <code>|&gt;</code> (currently at stage 1) pipes the value of an expression into a function. This allows the creation of chained function calls in a readable manner. The result is syntactic sugar in which a function call with a single argument can be written like this:</p>

<pre class="brush: js notranslate">let url = "%21" |&gt; decodeURI;</pre>

<p>The equivalent call in traditional syntax looks like this:</p>

<pre class="brush: js notranslate">let url = decodeURI("%21");
</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>expression</var> |&gt; <var>function</var>
</pre>

<p>The value of the specified <code><var>expression</var></code> is passed into the <code><var>function</var></code> as its sole parameter.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>expression</var></code></dt>
 <dd>Any valid expression.</dd>
 <dt><code><var>function</var></code></dt>
 <dd>Any function.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Chaining_function_calls">Chaining function calls</h3>

<p>The pipeline operator can improve readability when chaining several functions.</p>

<pre class="brush: js notranslate">const double = (n) =&gt; n * 2;
const increment = (n) =&gt; n + 1;

// without pipeline operator
double(increment(double(double(5)))); // 42

// with pipeline operator
5 |&gt; double |&gt; double |&gt; increment |&gt; double; // 42
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Pipeline operator', '#sec-intro', 'Pipeline operator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.pipeline")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://github.com/tc39/proposal-pipeline-operator">Github - Proposal-pipeline-operator</a></li>
 <li><a href="https://github.com/tc39/proposals">TC39 proposals</a></li>
</ul>
